<button type="button" (click)="submitForm()">Submit test</button>

<form [formGroup]="resumeBuilder" #form>
    <mat-vertical-stepper #stepper>
        <!-- Personal Details -->
        <mat-step label="Personal Details" [stepControl]="resumeBuilder.get('personal_details')">
            <div formGroupName="personal_details">
                <div class="form-container">
                    <div class="row">
                        <div class="col-12 col-md-6">
                            <mat-form-field class="full-width-input">
                                <input
                                    matInput
                                    placeholder="First Name"
                                    required
                                    formControlName="first_name"
                                    type="text"
                                />
                                <mat-error>Please enter your first name</mat-error>
                            </mat-form-field>
                        </div>
                        <div class="col-12 col-md-6">
                            <mat-form-field class="full-width-input">
                                <input
                                    matInput
                                    placeholder="Last Name"
                                    required
                                    formControlName="last_name"
                                    type="text"
                                />
                                <mat-error>Please enter your last name</mat-error>
                            </mat-form-field>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12 col-md-8">
                            <mat-form-field class="full-width-input">
                                <input matInput placeholder="Email ID" required formControlName="email" type="text" />
                                <mat-error *ngIf="email.invalid && email['errors']['required']">Please enter an Email ID</mat-error>
                                <mat-error *ngIf="email.invalid && email['errors']['email']">Please enter a valid Email ID</mat-error>
                            </mat-form-field>
                        </div>
                        <div class="col-6">
                            <mat-form-field class="full-width-input">
                                <input
                                    matInput
                                    [matDatepicker]="picker"
                                    placeholder="Date of Birth"
                                    formControlName="date_of_birth"
                                />
                                <mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
                                <mat-datepicker touchUi #picker></mat-datepicker>
                                <mat-error *ngIf="dateOfBirth.invalid && dateOfBirth['errors']['required']">Please enter your date of birth</mat-error>
                            </mat-form-field>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-6">
                            <mat-form-field class="full-width-input">
                                <input matInput placeholder="Mobile Number" required formControlName="mobile_number" />
                                <mat-error *ngIf="mobileNumber.invalid && mobileNumber['errors']['pattern']">Please a valid mobile number (only digits)</mat-error>

                            </mat-form-field>
                        </div>
                        <div class="col-6">
                            <mat-form-field class="full-width-input">
                                <input matInput placeholder="Home Number" formControlName="home_number" />
                                <mat-error *ngIf="homeNumber.invalid && homeNumber['errors']['pattern']">Please a valid home number (only digits)</mat-error>
                            </mat-form-field>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12">
                            <mat-form-field class="full-width-input">
                                <textarea matInput placeholder="Address" required formControlName="address"></textarea>
                                
                            </mat-form-field>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-6">
                            <mat-form-field class="full-width-input">
                                <input matInput placeholder="Languages Spoken" required formControlName="languages" />
                                

                            </mat-form-field>
                        </div>
                        <div class="col-6">
                            <mat-form-field class="full-width-input">
                                <input matInput placeholder="Hobbies" formControlName="hobbies" />
                            </mat-form-field>
                        </div>
                    </div>
                </div>
            </div>
            <div class="button-row stepper-buttons">
                <button mat-button matStepperNext type="button">Next</button>
            </div>
        </mat-step>
        <!-- Education -->
        <mat-step label="Education" [stepControl]="resumeBuilder.get('education')">
            <div formArrayName="education">
                <div class="form-container">
                    <!---Start NgFor -->
                    <div
                        [formGroupName]="i"
                        *ngFor="let institute of resumeBuilder.get('education')['controls']; let i = index"
                    >
                        <div class="row">
                            <div class="col-md-6 col-12">
                                <mat-form-field class="full-width-input">
                                    <mat-select placeholder="Institute Name" required formControlName="institute_name">
                                        <mat-option *ngFor="let ins of institutes" [value]="ins">
                                            {{ ins }}
                                        </mat-option>
                                    </mat-select>
                                </mat-form-field>
                            </div>
                            <div class="col-md-6 col-12">
                                <mat-form-field class="full-width-input">
                                    <input matInput placeholder="Course Name" formControlName="course_name" />
                                </mat-form-field>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-6 col-12">
                                <mat-form-field class="full-width-input">
                                    <input matInput placeholder="Start Date" formControlName="start_year" />
                                </mat-form-field>
                            </div>
                            <div class="col-md-6 col-12">
                                <mat-form-field class="full-width-input">
                                    <input matInput placeholder="End Date" formControlName="end_year" />
                                </mat-form-field>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-12">
                                <mat-form-field class="full-width-input">
                                    <textarea
                                        matInput
                                        placeholder="Description"
                                        formControlName="description"
                                    ></textarea>
                                </mat-form-field>
                            </div>
                        </div>
                        <div class="button-row">
                            <button
                                type="button"
                                mat-raised-button
                                color="primary"
                                (click)="addNewEducation()"
                                [disabled]="!(education.length < 3)"
                            >
                                Add
                            </button>

                            <button
                                type="button"
                                mat-button
                                (click)="removeEducation(i)"
                                [disabled]="!(education.length > 1)"
                            >
                                Remove
                            </button>
                        </div>
                    </div>
                    <!-- End ngFor -->
                </div>
            </div>
            <div class="button-row stepper-buttons">
                <button mat-button matStepperPrevious type="button">Back</button>
                <button mat-button matStepperNext type="button">Next</button>
            </div>
        </mat-step>
        <!-- Projects -->
        <mat-step label="Projects" [stepControl]="resumeBuilder.get('projects')">
            <div formArrayName="projects">
                <div class="form-container">
                    <div
                        [formGroupName]="i"
                        *ngFor="let project of resumeBuilder.get('projects')['controls']; let i = index"
                    >
                        <div class="row">
                            <div class="col-12">
                                <mat-form-field class="full-width-input">
                                    <input
                                        matInput
                                        placeholder="Project Title"
                                        required
                                        formControlName="project_title"
                                    />
                                </mat-form-field>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-12">
                                <mat-form-field class="full-width-input">
                                    <textarea
                                        matInput
                                        placeholder="Project Description"
                                        required
                                        formControlName="project_description"
                                    ></textarea>
                                </mat-form-field>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-6">
                                <button
                                    type="button"
                                    mat-raised-button
                                    color="primary"
                                    (click)="addNewProject()"
                                    *ngIf="projects.length < 6"
                                >
                                    Add
                                </button>
                            </div>
                            <div class="col-6">
                                <button type="button" mat-button (click)="removeProject(i)" *ngIf="projects.length > 1">
                                    Remove
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="button-row stepper-buttons">
                <button mat-button matStepperPrevious type="button">Back</button>
                <button mat-button matStepperNext type="button">Next</button>
            </div>
        </mat-step>
        <!-- Certifications -->
        <mat-step label="Certifications" [stepControl]="resumeBuilder.get('certifications')">
            <mat-form-field class="full-width-input">
                <textarea matInput placeholder="Certifications" formControlName="certifications"></textarea>
            </mat-form-field>
            <button mat-button matStepperPrevious type="button">Back</button>
            <button mat-button matStepperNext type="button">Next</button>
        </mat-step>
        <!-- Internships -->
        <mat-step label="Internships" [stepControl]="resumeBuilder.get('internships')">
            <div formArrayName="internships">
                <div class="form-container"></div>
                <div
                    [formGroupName]="i"
                    *ngFor="let internship of resumeBuilder.get('internships')['controls']; let i = index"
                >
                    <div class="row">
                        <div class="col-12 col-md-6">
                            <mat-form-field class="full-width-input">
                                <input matInput placeholder="Organization Name" formControlName="org_name" />
                            </mat-form-field>
                        </div>
                        <div class="col-12 col-md-6">
                            <mat-form-field class="form-width-input">
                                <input matInput placeholder="Role/Designation" formControlName="role_or_designation" />
                            </mat-form-field>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-6">
                            <mat-form-field class="form-width-input">
                                <input matInput placeholder="Start Date" formControlName="start_year" />
                            </mat-form-field>
                        </div>
                        <div class="col-6">
                            <mat-form-field class="form-width-input">
                                <input matInput placeholder="End Date" formControlName="end_year" />
                            </mat-form-field>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12">
                            <mat-form-field class="form-width-input">
                                <input matInput placeholder="Description" formControlName="description" />
                            </mat-form-field>
                        </div>
                    </div>

                    <button
                        mat-raised-button
                        color="primary"
                        type="button"
                        (click)="addNewInternship()"
                        [disabled]="!(internships.length < 4)"
                    >
                        Add
                    </button>
                    <button
                        mat-button
                        (click)="removeInternship(i)"
                        type="button"
                        [disabled]="!(internships.length > 1)"
                    >
                        Remove
                    </button>
                </div>
            </div>
            <div class="button-row stepper-buttons">
                <button type="button" mat-button matStepperPrevious>Back</button>
                <button type="button" mat-button matStepperNext>Next</button>
            </div>
        </mat-step>
        <!-- Buttons -->
        <mat-step label="Done!">
            <h4 class="done-message">
                {{
                    resumeBuilder.valid
                        ? "You're done! Submit your form and check your email for your generated resume."
                        : "Looks like you've missed some fields or entered wrong information! Please go through the sections marked with a red exclamation and check your inputs."
                }}
            </h4>
            <div class="button-row">
                <button mat-button type="button" matStepperPrevious>
                    Previous
                </button>
                <button
                    mat-raised-button
                    color="primary"
                    type="button"
                    [disabled]="!resumeBuilder.valid"
                    (click)="submitForm()"
                >
                    Submit & Print
                </button>
                <button mat-button type="button" (click)="resetForm()">Reset</button>
            </div>
        </mat-step>
    </mat-vertical-stepper>
    <pre>{{ resumeBuilder.value | json }}</pre>
</form>
